{{ PanicHeader110713a

  ---- Private Notes -------
  110710a Move protected EEPROM to end of 64K.
  This way the beginning can be free to use for
  frimware updates.
  
  ---- Public Notes -------
  
  
}} 
CON
{


  $FF00  |                   |                   |                   |                   |
  $FF10  |                   |                   |                   |                   |
  $FF20  |                   |                   |                   |                   |
  $FF30  |                   |                   |                   |                   |
  $FF40  |                   |                   |                   |                   |
  $FF50  |                   |                   |                   |                   |
  $FF60  |                   |                   |                   |                   |
  $FF70  |                   |                   |                   |                   |
  $FF80  |                   |                   |                   |                   |
  $FF90  |                   |                   |                   |                   |
  $FF00  |                   |                   |                   |                   |
  $FFA0  |                   |                   |                   |                   |
  $FFC0  |        6          |        6          |        5          |        5          |
  $FFD0  |        4          |        4          |        3          |        3          |
  $FFE0  | Unit #2 firmware  |subV2, code2, X, X | Unit #1 firmware  |subV1, code1, X, X |
  $FFF0  | _FirmwareVersion  |_FirmwareSubVersion|                   |     Unit ID       |
  
  The basestation will have the firmware version of each other unit in it's EEPROM.
  Unit #N's fw location = _FirmwareLocation - (N * _FirmwareDiscriptionSize)  
}
  _FirmwareDiscriptionSize = 8 ' 4 for date, 1 for subV letter, 3 for other codes
                               ' codes include fw update started or successfully finished
  _FirmwareVersion = 110713  ' 4 bytes
  _FirmwareSubVersion = "a"  ' 1 byte, for now the following three bytes
  _FirmwareLocation = $FFF0
  _FirmwareSubLocation = _FirmwareLocation + 4 ' three last bytes aren't used yet
  _IdEepromLocation = _FirmwareLocation + 12 ' 4 bytes
  _FirstProtectedEeprom = _FirmwareLocation
  _EndOfProtectedEeprom = _FirmwareLocation + 16

  
  ' EEPROM firmware update codes
  #0, _NoInfoYetFw, _UpdateStartedFw, _UpdateComplete ' Firmware updates will first be copied
                                                      ' to uppper EEPROM then from upper EEPROM
                                                      ' to lower EEPROM.

  ' Nodic ID enumberation
  #0, _BaseNordic, _PinkNordic, _RedNordic, {_OrangeNordic,} _YellowNordic, { 0 - 3 '0 - 4
    } _GreenNordic, _BlueNordic, _VioletNordic, _Fob0Nordic, _Fob1Nordic ' 4 - 8 '5 - 9

  _ButtonUnitsUsed = _Fob1Nordic ' Not counting the baseStation

  ' Upgrade path enumeration
  #0, _WiredUpgrade, _WirelessUpgrade

  _CurrentUpgradePath = _WiredUpgrade

  _FirmwareScratchPadLocation = $8000

  ' button type
  #3, _FobPanicTx, _ButtonPanicTx, _FobPanicAckRoutedTx, _ButtonPanicAckRoutedTx, { 3 - 6
    } _CheckInRequestTx, _CheckInAckTx, _CheckInRequestRoutedTx, _CheckInAckRoutedTx, { 7 - 10
    } _FobPanicAckTx, _ButtonPanicAckTx ' 11 - 12
  
CON
'' Communication protocol.  Board to board.
  '' Wireless boards:
  '' _StartOfHeader, _StartOfText, button type,  origination, board ASCII number,
  '' (other unit ASCII numbers * (_ButtonUnitsUsed - 3(minus two FOBs and final distination number)))
  '' (_Enquire, _Acknowledgment or _Command) 
  '' [type of E, A or C] [parameters] _CarriageReturn
  ''
  '' *1 Is this needed?  All wired com will go directly to one board.  Receiving board should be told the destination so it
  ''    knows if it needs to act on the communcation or just pass it on.  Probably leave in.
  '' *2 The transceiver may need to be configured to transmit to different boards.
  '' *3 Transmission count (use txCount) will increment by one each transmission so receiving board will know if data is repeated.
  ''    An ackowledgment will include the original count as a parameter.  (Use RxCountOld and RxCountNew)
{{
  Boards A and B communications
  Since board B will only be communicating with board A the protocol will be different.
  Board B will add a small header to indicate the type of information being transmitted.
  There will be an uppercase letter to indicate the type of information followed by an colon.
  The letters supported so far are:
  A: for analytical balance data.
    After the header the weight will be transmitted ending with the character "g".
    The numbers 0-9, a decimal point "." and a leading negative may be part of the
    transmission.  The balance transmits a "+" to indicate positive weight; this character
    is ignored by board B.  There are also several space characters transmitted after the
    plus sign.  These are also ignored.
  L: for large balance data.
    After the header the weight will be transmitted ending with the character "g".
    The numbers 0-9, a decimal point "." and a leading negative may be part of the
    transmission.  The large balance does not transmit a negative sign (I don't know why).
    The "g" character indicates the end of the weight information.  The balance transmits
    additional characters after the weight which is ignored by board B.
  S: for spectrometer data.  This may need a sub header to indicate the type of spectrometer data.
    The spectrometer data will be passed on to board A with the space characters removed and a
    comma added to separate the fields.  Wave length (ending with NM), decimal number with posible
    negative sign, single letter mode indicator.  Board A will need to monitor this information to
    make sure the correct wavelength is being used and to make sure the spectrometer is in the
    correct mode.  Board A may change the mode automatically by transmitting the appropiate command
    to the spectrometer.
  B: for barcode data.
    Board B should not need to modify the data it receives from the barcode reader.  Board A
    will use the intial characters of the barcode to determine the type of container.
  E: error message.
    Possible errors include: spectrometer in the wrong mode.
    Board B should make an error sound with its piezo speaker.  
  D: not any of above, other communication.  Probably just to pass on to be displayed.
    Should everything that is displayed also be recorded?  Not for now.
    Is everthing that is displayed also spoken by the eMic module?
  X: debug input on board B.
    Just pass it along to boards C and H and record it to SC card.
  Each data packet will end with a carriage return(13).

  Wireless transmission will be acknowledged with the character R followed by the setCount variable
  sent back to originating board.

  The object pcFullDuplexSerial4FC512FlagsPlus110304a sets the acknowledge flag from within the PASM
  section of the driver (only on port 0).

  
}}  
  'Control ASCII characters used in object.              
  {_StartOfHeader = 1
  _StartOfText = 2
  _SendToWireLess = 3          ' Used by board F to acknowledge to G a wireless Tx was send and has been received by distination
                                ' board.
  _Command = 4                 ' Followed by board destination. Use to indicate action required by other Prop such as lighting a LED
  _Enquire = 5                  ' Follow by board destination.  (A to F or higher in future)
  _Acknowledgment = 6
  _CarriageReturn = 13          ' I doubt I'll use the constant's name.  I'll just type 13.
  '' _Enquire types
  '' Also use in CheckStylusDown method as modes
  _Button = 14
  _ButtonAndKnob = 15
  _ButtonKnobAndKey = 16
  _ButtonKnobKeyAndNunchuck = 17
  '' _Command types
  _LedSingle = 18
  _LedGroup = 19
  _StopTxNunchuckToRoboni0 = 20
  _StartTxNunchuckToRoboni0 = 21  }

  #0, _Null, _StartOfHeader, _StartOfText, _SendToWireLess, _Command, _Enquire, _Acknowledgment, { 0-6

    _Enquire types, Also use in CheckStylusDown method as modes
    } _Button, _ButtonAndKnob, _ButtonKnobAndKey, _ButtonKnobKeyAndNunchuck, _LedSingle, _LedGroup, { 7-12
    } _CarriageReturn, _StopTxNunchuckToRoboni0, _StartTxNunchuckToRoboni0   {13-15} 
  
  _WirelessAck = "R"

 
 ' Pin Definitions

  _DebugTxPin = 30
  _DebugRxPin = 31
  
  _DebugBaudA = 57600  
  _DebugBaudB = 57600  
  _DebugBaudC = 57600   
  _DebugBaudD = 57600
  _DebugBaudE = 57600  
  _DebugBaudF = 57600  
  _DebugBaudG = 57600    
  _DebugBaudH = 57600    
  _DebugBaudZ = 57600    
  _DebugBaudTestBoard1 = 57600    
  _DebugBaudMecanum = 57600
  _InterMecanumBaud = 57600
      
  _ABBoardsBaud = 57600
  _BCBoardsBaud = 57600
  _XBeeBaud = 9600
  _EmicBaud = 2400
  _FieldSizeComrade = 12
 
  _LargeBufferSize = 512 '128 '32
  _LargestStructureSize = 32 '_LargeBufferSize
  
  
'' Firmware Communication Protocol

  
'' Button Press Communication Protocol


'' Check In Communication Protocol


         
CON

  'Pins to Nordic0 nRF24L01+
  _DefaultSpiIrq = 14
  _DefaultSpiMiso = 12
  _DefaultSpiMosi = 10
  _DefaultSpiSck = 8 
  _DefaultSpiCsn = 6     
  _DefaultSpiCe = 4
  

  _LargestPayloadSize = 32
  _DefaultPayloadSize = _LargestPayloadSize
 
  _InitialAddressCharacter = $E7
  
CON
                                       '1         2         3
                             '01234567890123456789012345678901




''------------------ Cofig settings for new nRF24L01+ modules ----------------------------------------
'' ----------------- Keep below together and in order ------------------------------------------------
  _Config0 = %00111111 '%00111011  Register $00
              ' use %00111111($3F)(2 bytes CRC) or %00111011($3B)(1 byte CRC)
              ' when communicating with older nRF2401A modules
              ' make sure this matches nRF2401A setting
              ' %00001111($0F) future with more irq options
              ' 7 only zero allowed, 6 Mask irq by RX_DR (1 = no irq), 5 Mask TX_DS, 4 Mask MAX_RT,
              ' 3 Enable CRC, 2 CRC size (1 = 2 bytes), 1 1 = power up, 0 1 = PRX 0 = PTX
              ' RX_DR Receive Data Ready
              ' TX_DS Transmit Data Sent
              ' MAX_RT Maximum Retries
  _Config1 = $00 '$03 ' Register $01 Auto Acknowledge
              ' use $00 when communicating with older nRF2401A modules
              ' %00111111 future
              ' 7:6 only %00, enable pipe 5 through 0
  _Config2 = %00000011 ' Register $02
              ' 7:6 only zero allowed, 5:0 enable rx addresses pipe 5:0
  _Config3 = $03 ' Register $03 SETUP_AW setup Address Widths 
              ' 7:2 only %000000, 1:0 %01 = 3 %11 = 5
  _Config4 = $00 ' Register $04 SETUP_RETR Setup Auto Retransmission
              ' use $00 when communicating with older nRF2401A modules     
              ' %00101111 = 750us delay to retx, tx 15 tries
              ' %01001111 = 1250us delay to retx, tx 15 tries
              ' 7:4 ARD delay 1111 = 4000us, 3:0 retry count 0 - 15 (1111)
  _Config5 = $02 ' Register $05 RF_CH RF Channel
              ' 7 leave 0, 6:0 frequency channel
              ' F = (2400 + RF_CH)MHz (both nRF24L01+ and nRF2401A modules)
  _Config6 = $06 ' Register $06 RF_SETUP RF Setup
              ' don't use 2Mbps when communicating with older nRF2401A modules
              ' $06 = 1Mbps and full power
              ' 7:6 %00 only, 5 RF_DR_LOW 1 = 250kbps use 0 for higher speeds, 4 leave %0
              ' 3 1 = 2Mbps 0 = 1Mbps, 2:1 RF_POWER %11 = 0dBm (highest power), 0 don't care
              ' Register $07 STATUS Status Register used below.
              ' Register $08 OBSERVE_TX 7:4 lost packet count (read only),
              ' 3:0 retransmitted packets count (read only).  I plan to use this
              ' register's infomation in the future.
              ' Register $09 RPD 7:1 reserved (read only), 0 Received Power Detector (read only)
              ' Register $0A RX_ADDR_P0 39:0 Receive address pipe 0, 5 bytes maximum LSByte written first
              ' used below rxAddress0 and rxAddress1
              ' Register $0B RX_ADDR_P1 39:0 Receive address pipe 1
              ' Register $0C RX_ADDR_P2 7:0 Receive address pipe 2
              ' Register $0D RX_ADDR_P3 7:0 Receive address pipe 3
              ' Register $0E RX_ADDR_P4 7:0 Receive address pipe 4
              ' Register $0F RX_ADDR_P5 7:0 Receive address pipe 5
              ' Register $10 TX_ADDR 39:0 Transmit address
'configNew[7]
  _RxPayload = 25 '32   ' Register $11 RX_PW_P0
              ' This will need to be reduced to 25 (assuming 2 bytes CRC and 5 bytes address)
              ' to work with older nRF2401 modules.
              ' Newer nRF24L01+ modules can have payloads as large as 32 bytes.
              ' 7:6 only zero allowed, 5:0 Number of bytes in RX payload in data pipe 0
              ' (1 to 32)(0 = pipe not used)
              ' Register $12 RX_PW_P1 7:6 only zero allowed,
              ' 5:0 Number of bytes in RX payload in data pipe 1
              ' (1 to 32)(0 = pipe not used)
              ' Register $13 RX_PW_P2 7:6 only zero allowed,
              ' 5:0 Number of bytes in RX payload in data pipe 2
              ' Register $14 RX_PW_P3 7:6 only zero allowed,
              ' 5:0 Number of bytes in RX payload in data pipe 3
              ' Register $15 RX_PW_P4 7:6 only zero allowed,
              ' 5:0 Number of bytes in RX payload in data pipe 4
              ' Register $16 RX_PW_P5 7:6 only zero allowed,
              ' 5:0 Number of bytes in RX payload in data pipe 5
              ' Register $17 FIFO_STATUS 7 only zero allowed, 6 TX_REUSE (read only), 
              ' 5 TX_FULL %1 = full (read only), 4 TX_EMPTY %1 = empty (read only),
              ' 3:2 only zero allowed, 1 RX_FULL %1 = full (read only),
              ' 0 RX_EMPTY %1 = empty (read only)
              ' Register $1C DYNPD Enable dynamic payload length, 7:6 only zero allowed,
              ' 5 DPL_P5 Enable dynamic payload length data pipe 5 (Requires EN_DPL and ENAA_5)
              ' 4 DPL_P4 Enable dynamic payload length data pipe 4 (Requires EN_DPL and ENAA_4)
              ' 3 DPL_P3 Enable dynamic payload length data pipe 3 (Requires EN_DPL and ENAA_3)
              ' 2 DPL_P2 Enable dynamic payload length data pipe 2 (Requires EN_DPL and ENAA_2)
              ' 1 DPL_P1 Enable dynamic payload length data pipe 1 (Requires EN_DPL and ENAA_1)
              ' 0 DPL_P0 Enable dynamic payload length data pipe 0 (Requires EN_DPL and ENAA_0)
              ' Register $1D FEATURE Feature Register 7:3 only zero allowed,
              ' 2 EN_DPL Enables Dynamic Payload Length, 1 EN_ACK_PAY Enables Payload with ACK,
              ' 0 EN_DYN_ACK Enables the W_TX_PAYLOAD_NOACK command
              
'' ----------------- Keep above together and in order ------------------------------------------------             
  _NordicStatus = %01000000 ' $40   %01110000   '$70
              ' only zero allowed, Data Ready RX, TX ACK received, MAX_RT failed,
              ' 3:1 Data pipe with payload %111 if empty (read only), 0 1= TX FIFO full (read only)
'  ------------------------------------------------
PUB ThrowAwayMethod
'' One public method is required to compile object.


  